#include <Client.h>
#include <Ethernet.h>
#include <stdio.h>
#include <XBee.h>

#define TIEMPO_ESPERA 5000
#define TIEMPO_ESPERA2 1200000

// creas el objeto servidor, dando el lugar de IP del servidor y la puerta 

byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0x1D };
byte arduinoip[] = { 192, 168, 0, 118 };
byte ip[] = { 192, 168, 0, 100 };
Client client(ip,9999); //decimos que trabaje como client

// Aqui creamos los paquetes de Xbee
XBee xbee = XBee();
XBeeResponse response = XBeeResponse();
Rx16Response rx16 = Rx16Response();
int humedity;
int temperature;
int sensor;
char humedity_str[3];
char temperature_str[3];
char sensor_str[3];


uint8_t* data;

void setup() {
 Ethernet.begin(mac,arduinoip); // le damos una ip al arduino
 delay(1000);
 pinMode(13,OUTPUT); 
 pinMode(10,OUTPUT);
  xbee.begin(9600);
}

void loop() {
    
    //leemos los paquetes de que esta enviando el arduino de escritura
    xbee.readPacket();
    
    // si el modulo xbee ha escuchado bien pasa a comprobar si el paquete es como el enviado
    if (xbee.getResponse().isAvailable()) {
      // De este if pasa, no pasa del siguiente
      if (xbee.getResponse().getApiId() == RX_16_RESPONSE) {
		// si lo es obtiene la informacion
          xbee.getResponse().getRx16Response(rx16);
          sensor = rx16.getData()[0];
          temperature = rx16.getData()[1];
          humedity = rx16.getData()[2];
          itoa(humedity,humedity_str,10);
          itoa(temperature,temperature_str,10);
          itoa(sensor,sensor_str,10);
          digitalWrite(13,HIGH);
          delay(1000);
          digitalWrite(13,LOW);  
          delay(1000);
          digitalWrite(13,HIGH);
          delay(1000);
          digitalWrite(13,LOW);
          //da la senyal de confirmacion del paquete
   if(client.connected()){
     if(client.available()){
        int i = 0;
        char buf[255] = {}, c;
        while ((c = client.read()) != -1) {
           buf[i++] = c;
           if (i == sizeof(buf)){
             break;
           }
        }
        // el servidor hace el envio de confirmacion de conexion y lo comprueba
        if(strcmp(buf, "GET /xml-arduino/protocol HTTP/1.1\nHost: localhost\n") == 0){
            
		// efectuamos el paquete que hay que enviar al servidor
          char buf[1024];
      
          sprintf(buf, "HTTP/1.1 200 OK\n"
                    "Content-Type: text/plain;charset=UTF-8\n"
                    "Content-Length: 49\n\n"
                    "<xml><entry><sensor>%s</sensor><humedity>%s</humedity><temperature>%s</temperature></entry></xml>", sensor_str, humedity_str, temperature_str);
          client.print(buf);

        } else {
        }
        delay(TIEMPO_ESPERA2);
     }
     delay(TIEMPO_ESPERA);
   } else {
      client.stop();
      if (client.connect()){
      }else{
      delay(2000);
      }
    }  
  }
 }
}
